This is version 10 of BSD ftpd for MiNT. It was originally ported and
up to version 03 maintained by TeSche. All later versions are done by
me (Draco).

IMPORTANT NOTICE:

This is possibly last release of MiNT FTP server, because I've just
managed to do a preliminary port of wu-ftpd. Since that last is definitely
more modern and safe, you can expect the wu server to be released instead
of a next MiNT ftpd.

This may however take some days :)

I. Compiling

The included binary is compiled for 68030 machines. You should be able 
to compile this version using gcc 2.7.2 or 2.5.8 included in the KGMD 
package. Use MiNTNet 1.01 and MiNT => 1.14.7, then everything should work 
OK. MiNT kernel version 1.15.0 and up is recommended for full
functionality.

II. Features 

Since the version 05 all anonymous sessions should be more safe, as
users logged anonymously are no longer able to freely access the
filesystem. Because MiNT still doesn't support chroot(), all this 
stuff is done by the server using some form of internal pathname 
resolving routines. They *seem* to work correctly.

Options:

-w	get rid of initial `hello' message
-A	allow anonymous sessions only
-e	enable extra logging to /var/adm/ftp.log

Config files:

Since this version config files are searched in the directory /etc/ftpd.
These are:

- /etc/ftpd/ftpwelcome
  sent to the client as a welcome message after successful connection.
  it will be displayed before login.
- /etc/ftpd/ftpmotd
  sent to the client as `message of the day' after a successful anonymous
  login. For normal logins the file ~/.welcome is sent instead.
- /etc/ftpd/ftpusers
  list of user IDs those aren't allowed to login via FTP.
- /etc/ftpd/ftpchroot
  list of user IDs those are limited to their own $HOME only (like
  anonymous user is)
- ~/.welcome
  private welcome message used on normal (non-anonymous) accounts.
- ./.message
  description of folder contents, local in any directory; sent
  after a successful cd command to a particular directory.

All files inside /etc/ftpd should be owned by root and have -rw-r--r--
(644) permission code. .message should be owned by ftp (group: uucp) and
have permission -r-------- (400). .welcome should be owned by the owner of
the directory.

The server is now aware on /etc/nologin. If this file is found, the ftp
daemon will refuse all login requests.

III. Problems

a) /proc folder, problem I

Problem of unreadable (-r) home directories should be gone as of MiNT
kernel version 1.14.7.

b) /proc folder, problem II

Thanks to Comp7 is has been discovered that you can delete any system
process (including any root's one) using ftpd, by logging locally into
an user account, going to the /proc and using del command. It is
definitely a kernel problem, if it occurs for you, please go download
kernel 1.14.5 or later (where this bug is fixed).
 
c) garbage extralog

Seems to be gone.

d) anonymous symlinks

Servicing an anonymous session, the daemon does not follow symlinks 
if they point to outside the home directory of the anonymous user. 
Sorry guys, it is not a real bug! This is the way the pathname 
resolver works... So, if you want to give somebody an access to files 
stored on a CD-ROM, please grant him a real account on your machine...

IV. Installation

a) if you haven't had any server before:

To install ftpd, you've got to copy the binary to any appropriate place and
edit /etc/inetd.conf so that the `ftp' line looks like:

ftp	stream	tcp	nowait	root	/etc/ftpd	ftpd

or, if you'd like to enable logging:

ftp	stream	tcp	nowait	root	/etc/ftpd	ftpd -e

where you should replace /etc/ftpd with the path you've copied ftpd to, if
it's another one.

b) if you have the system installed from the Knarf's German MiNT
Distribution (KGMD) and you haven't altered the original server
configuration (i.e. the server is started using inetd):

Just type "make install" being in the directory containing the unpacked
archive.

c) if you have the ftp server installed as "stand alone" daemon:

Just type "make standalone" as above.

d) to install manuals type "make manual"

No warranty as ever, use it at your own risk.

Enjoy,
Draco
draco@mi.com.pl
